/* Copyright (C) 2013  Stephan Kreutzer
 *
 * This file is part of "Random Access File C Example".
 *
 * "Random Access File C Example" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 or any later version,
 * as published by the Free Software Foundation.
 *
 * "Random Access File C Example" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License 3 for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with "Random Access File C Example". If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * @file $/example.cpp
 * @since 2013-11-26
 * @author Stephan Kreutzer
 */



#include <iostream>
#include <cstring>
#include "ra_file.h"



struct data_block
{
    int id;
    char name[30];
};



int main(int argc, char** argv)
{
    {
        data_block data_out;
        data_out.id = 42;
        std::strncpy(data_out.name, "Guy 1\0", sizeof(data_out.name) - 1);

        ra_file file_out;
        file_out.open("test.data", "w");

        file_out.raf_add(&data_out, sizeof(data_block), 0, sizeof(data_block));
    }

    {
        data_block data_in;

        ra_file file_in;
        file_in.open("test.data", "r");

        file_in.raf_read(&data_in.id, 0, sizeof(data_in), 0, sizeof(data_in.id));
        file_in.raf_read(&data_in.name, 0, sizeof(data_in), sizeof(data_in.id), sizeof(data_in.name));

        std::cout << data_in.id << ": " << data_in.name << std::endl;
    }

    {
        data_block data_out;
        std::strncpy(data_out.name, "Guy 2\0", sizeof(data_block::name) - 1);

        ra_file file_out;
        file_out.open("test.data", "w");

        file_out.raf_write(&data_out, 0, sizeof(data_block), sizeof(data_block::id), sizeof(data_block::name));
    }

    {
        data_block data_in;

        ra_file file_in;
        file_in.open("test.data", "r");

        file_in.raf_read(&data_in.id, 0, sizeof(data_in), 0, sizeof(data_in.id));
        file_in.raf_read(&data_in.name, 0, sizeof(data_in), sizeof(data_in.id), sizeof(data_in.name));

        std::cout << data_in.id << ": " << data_in.name << std::endl;
    }


    return 0;
}
